<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="grid">
    <div class="col-12">
        <div class="card">
            <h5 class="text-blue-500 font-bold"><i class="pi pi-clock text-4xl"></i>จัดการช่วงเวลา</h5>
            <p-table #pnl [value]="periods" scrollDirection="both" [paginator]="true" [rows]="10" [scrollable]="true"
            [showCurrentPageReport]="true" styleClass="mt-3" responsiveLayout="scroll"
            currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
            [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['period_name']"
            [rowHover]="true">
            <ng-template pTemplate="caption">
                <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                    <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                        <i class="pi pi-search"></i>
                        <input pInputText type="text" (input)="onGlobalFilter(pnl, $event)" placeholder="ค้นหา"
                            class="w-full" />
                    </span>
                    <button (click)="displayFormAdd()" pButton class="p-button w-full sm:w-auto flex-order-0 sm:flex-order-1" icon="pi pi-plus-circle" label="เพิ่มช่วงเวลา"></button>
                </div>
            </ng-template>
                <ng-template pTemplate="header">
                    <tr>
                        <th class="text-center">ลำดับ</th>
                        <th pSortableColumn="period_name">ช่วงเวลา<p-sortIcon field="period_name"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="is_active">สถานะการใช้งาน<p-sortIcon field="is_active"></p-sortIcon></th>
                        <th class="text-center">จัดการ</th>
                    </tr>
                </ng-template>
                <ng-template pTemplate="body" let-periods let-i="rowIndex">
                    <tr>
                        <td class="text-center">{{i+1}}</td>
                        <td>{{periods.period_name}}</td>
                        <td class="text-center">
                            <p-tag *ngIf="periods.is_active" severity="success" value="เปิดใช้งาน"></p-tag>
                            <p-tag *ngIf="!periods.is_active" severity="danger" value="ปิดใช้งาน"></p-tag>
                        </td>
                        <td class="text-center">
                            <button type="button" pButton pRipple icon="pi pi-pencil" class="h-1rem mr-2 p-button-warning p-button-raised" (click)="displayFormEdit(periods)" pTooltip="แก้ไขข้อมูล" tooltipPosition="bottom"></button>
                        </td>
                </ng-template>
            </p-table>
        </div>
    </div>

    <p-dialog [(visible)]="displayForm" [style]="{ width: '50vw' }">
        <ng-template pTemplate="header">
            <h5 *ngIf="isAdd">เพิ่มช่วงเวลา</h5>
            <h5 *ngIf="isEdit">แก้ไขช่วงเวลา</h5>
            <p-messages [(value)]="messages" [enableService]="false" [closable]="false"></p-messages>
        </ng-template>
        <ng-template pTemplate="content">
            <div *ngIf="isAdd" class="p-fluid">
                <div class="p-field">
                    <div class="p-inputgroup">
                    <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                    <input type="text" id="period_name" [(ngModel)]="periodsName" pInputText placeholder="ช่วงเวลา">
                    </div>
                </div>
            </div>


            <div *ngIf="isEdit" class="p-fluid">
                <div class="p-field">
                        <div class="p-inputgroup">
                            <span class="p-inputgroup-addon"><i class="pi pi-chevron-circle-right"></i></span>
                            <input type="text" id="period_name" [(ngModel)]="periodsNameEdit" pInputText placeholder="ช่วงเวลา">
                        </div>
                </div>
                <div class="col-12 md:col-6">
                    <h5>สถานะการใช้งาน</h5>
                    <p-inputSwitch [(ngModel)]="periodsActiveEdit"></p-inputSwitch>
                </div>
            </div>
        </ng-template>

        <ng-template pTemplate="footer">

            <button *ngIf="isAdd" type="button"  pButton pRipple icon="pi pi-check-circle" class="p-button-raised p-button-success" (click)="save()" label="เพิ่มรายการ"></button>
            <button *ngIf="isEdit" type="button" pButton pRipple icon="pi pi-check-circle" class="p-button-raised p-button-success" (click)="update()" label="บันทึกแก้ไข"></button>
        </ng-template>



    </p-dialog>
</div>
